import java.io.*;

class MyReader extends BufferedReader {
	
	static final int READTO_SIZE = 64;
	private boolean empty = false;
	
	public MyReader(Reader in) {
		super(in);
	}
	
	public MyReader(Reader in, int sz) {
		super(in, sz);
	}
	
	public String readToNext(String delim) throws IOException {
		return readToNext(delim, true);
	}
	
	public String readToNext(String delim, boolean includeDelim) throws IOException {
		if (empty) return null; // may not catch all cases, e.g. if emptied by readLine()
		StringBuffer sb = new StringBuffer();
		char[] cbuf;
		int r = 0;
		int pos = -1;

		while (pos == -1 && r != -1) {
			cbuf = new char[READTO_SIZE];
			mark(READTO_SIZE); // change
			r = read(cbuf, 0, READTO_SIZE);
			if (r > 0) {
				sb.append(cbuf, 0, r);
			}
			pos = sb.indexOf(delim);
		}
		if (pos != -1) {
			reset(); // change
			int sk = r - (sb.length() - pos) + delim.length();
			skip(sk);

			return sb.substring(0, pos + (includeDelim ? delim.length() : 0));
		}
		else { // (r == -1)
			empty = true;
			if (sb.length() == 0) return null;
			else return sb.toString();
		}
	}
	
	
	public static void main(String[] args) throws Exception {
		MyReader mr = new MyReader(new InputStreamReader(System.in));
		System.out.println(mr.readToNext("EOF", false));
		System.out.println(mr.readLine());
	}
}
